//-----------------------------------------------------------------------------
// Casio Basic inside
//-----------------------------------------------------------------------------
extern char CB_G1MorG3MDefault;	// 1:G1M  3:G3M
extern char CB_G1MorG3M;		// 1:G1M  3:G3M
extern unsigned short CB_ColorIndexEditBack;	// Edit back color (default white)
extern unsigned short CB_ColorIndexEditBase;	// Edit color (default black)
extern unsigned short CB_ColorIndexEditCMD ;	// Edit CMD color (default blue)
extern unsigned short CB_ColorIndexEditQuot;	// Edit Quot  color (default magenta)
extern unsigned short CB_ColorIndexEditComt;	// Edit Comment color (default green)
extern unsigned short CB_ColorIndexEditLine;	// Edit LineNumber color (default blue)
extern unsigned short CB_ColorIndexEditNum ;	// Edit Numeric color (default black)
extern unsigned short CB_ColorIndexPlot;		// plot color index
extern unsigned short CB_BackColorIndex;		// Back color index (default White)
extern int			  CB_ColorIndex;			// current color index
extern int			  CB_BackPict;				// back image

extern  int ScreenWidth;	// 383 or 127
extern  int ScreenHeight;	// 191 or  63

extern char CB_INTDefault;	// default mode  0:normal  1: integer mode

extern char	DrawType  ;	// 0:connect  1:Plot
extern char	Coord     ;	// 0:off 1:on
extern char	Grid      ;	// 0:off 1:on
extern char	Axes      ;	// 0:off 1:on
extern char	Label     ;	// 0:off 1:on
extern char	Derivative     ;	// 0:off 1:on
extern char	PlotLineColor	;	// default:green

#define S_L_Normal   0
#define S_L_Thick    1
#define S_L_Broken   2
#define S_L_Dot      3
#define S_L_Thin     4
#define S_L_Default  -1

extern char S_L_Style;		// set line style 
extern char tmp_Style;		// set line style 
extern char Angle;			// 0:deg  1:rad  2:grad
extern char	Plot_Style ;	// Plot style 

extern double Previous_X ;	// Line Previous X
extern double Previous_Y ;	// Line Previous Y
extern double Previous_X2 ;	// Line Previous X2
extern double Previous_Y2 ;	// Line Previous Y2
extern int Previous_PX   ;	// Plot Previous PX
extern int Previous_PY   ;	// Plot Previous PY
extern double Plot_X     ;	// Plot Current X
extern double Plot_Y     ;	// Plot Current Y

extern char BreakCheck;	// Break Stop on/off
extern char ACBreak;	// AC Break on/off

extern char TimeDsp;
extern char MatXYmode;
extern char PictMode;	// StoPict/RclPict  StrageMem:0  heap:1
extern char CheckIfEnd;	// If...IfEnd check  0:off  1:on
extern char RefreshCtrl;	// 0:no refresh   1: GrphicsCMD refresh     2: all refresh
extern char Refreshtime;	// Refresh time  n/128

extern short DefaultWaitcount;	// wait control
extern short Waitcount;			// current wait control
extern char  CommandInputMethod;	//	0:C.Basic  1:Genuine
//-----------------------------------------------------------------------------
// Casio Basic Gloval variable
//-----------------------------------------------------------------------------
extern double  REG[26+6+26];
extern double  REGv[11];
extern double  VWIN[6][11];
extern char VWinflag[6];		// VWin flag

#define regA REG[ 0]
#define regB REG[ 1]
#define regC REG[ 2]
#define regD REG[ 3]
#define regE REG[ 4]
#define regF REG[ 5]
#define regG REG[ 6]
#define regH REG[ 7]
#define regI REG[ 8]
#define regJ REG[ 9]
#define regK REG[10]
#define regL REG[11]
#define regM REG[12]
#define regN REG[13]
#define regO REG[14]
#define regP REG[15]
#define regQ REG[16]
#define regR REG[17]
#define regS REG[18]
#define regT REG[19]
#define regU REG[20]
#define regV REG[21]
#define regW REG[22]
#define regX REG[23]
#define regY REG[24]
#define regZ REG[25]
#define reg_r 		REG[26]	// [	<r>
#define reg_Theta	REG[27]	// \	Theta
#define reg_Ans		REG[28]	// ]	Ans
#define reg29 REG[29]	// ^
#define reg30 REG[30]	// _
#define reg31 REG[31]	//


#define Xmin REGv[ 0]
#define Xmax REGv[ 1]
#define Xscl REGv[ 2]
#define Ymin REGv[ 3]
#define Ymax REGv[ 4]
#define Yscl REGv[ 5]
#define TThetamin  REGv[ 6]
#define TThetamax  REGv[ 7]
#define TThetaptch REGv[ 8]

#define Xdot REGv[ 9]
#define Ydot REGv[10]


extern	double Xfct;
extern	double Yfct;

#define ArgcMAX 10
extern	double 	*LocalDbl[26+6+26];		// local var ptr
extern	int		*LocalInt[26+6+26];		// local var ptr

extern double	*traceAry;		// Graph trace array

#define GraphStrMAX 64
extern char *GraphY;
extern char *GraphX;

#define const_PI 3.1415926535897932

#define PictMax 99
extern unsigned char *PictAry[PictMax+1];		// Pict array ptr

extern char BG_Pict_No;

#define PictbaseCountMAX 20
#define PictbaseMAX 20
extern unsigned char *Pictbase[PictbaseMAX];
extern short PictbasePtr;
extern short PictbaseCount;

//------------------------------------------------------------------------------
extern int  REGINT[26+6+26];

#define regintA REGINT[ 0]
#define regintB REGINT[ 1]
#define regintC REGINT[ 2]
#define regintD REGINT[ 3]
#define regintE REGINT[ 4]
#define regintF REGINT[ 5]
#define regintG REGINT[ 6]
#define regintH REGINT[ 7]
#define regintI REGINT[ 8]
#define regintJ REGINT[ 9]
#define regintK REGINT[10]
#define regintL REGINT[11]
#define regintM REGINT[12]
#define regintN REGINT[13]
#define regintO REGINT[14]
#define regintP REGINT[15]
#define regintQ REGINT[16]
#define regintR REGINT[17]
#define regintS REGINT[18]
#define regintT REGINT[19]
#define regintU REGINT[20]
#define regintV REGINT[21]
#define regintW REGINT[22]
#define regintX REGINT[23]
#define regintY REGINT[24]
#define regintZ REGINT[25]
#define regint_r 		REGINT[26]	// [	<r>
#define regint_Theta	REGINT[27]	// \	Theta
#define regint_Ans		REGINT[28]	// ]	Ans
#define regint29 REGINT[29]	// ^
#define regint30 REGINT[30]	// _
#define regint31 REGINT[31]	//

//------------------------------------------------------------------------------
extern int	CB_TicksStart;
extern int	CB_TicksEnd;
extern int	CB_TicksAdjust;

extern char ScreenMode;	//  0:Text  1:Graphic
extern char UseGraphic;	// use Graph  ( no use :0    plot:1   graph:2   cls:3   other:99
extern char dspflag;	// 0:nondsp  1:str  2:num  3:mat 4:list
extern char MatdspNo;	// 

extern int CursorX;	// text cursor X
extern int CursorY;	// text cursor X

extern int CB_INT;		// current mode  0:normal  1: integer mode
extern int ExecPtr;
extern int BreakPtr;

extern int CBint_CurrentValue;	// Ans
extern double CB_CurrentValue;	// Ans

#define ProgMax 30
extern char ProgEntryN;		// how many subroutin
extern char ProgNo;			// current Prog No
extern char *ProgfileAdrs[ProgMax+1];
extern int   ProgfileMax[ProgMax+1] ;	// Max edit filesize 
extern char  ProgfileEdit[ProgMax+1];	// no change : 0     edited : 1
extern char  ProgfileMode[ProgMax+1];	// g1m : 0    text : 1
extern char  ProgLocalN[ProgMax+1];
extern char  ProgLocalVar[ProgMax+1][26];

extern  char *TVRAM;
extern  char *GVRAM;
extern  char *BufVRAM;
extern  char *WorkBuf;
extern  char *PictBuf;
//------------------------------------------------------------------------------
#define StackGotoMax 10+26+2+6+26
#define StackGosubMax 4
#define IfCntMax 32
#define RemCntMax 32
#define StackForMax 4
#define StackWhileMax 4
#define StackDoMax 4
#define StackSwitchMax 4

#define TYPE_For_Next 			1
#define TYPE_While_WhileEnd		2
#define TYPE_Do_LpWhile			3
#define TYPE_Switch_Case		4

typedef struct {		// 8 bytes
	short	CNT;
	short	Prg;
	short	Ptr[IfCntMax];
	short	Adrs[IfCntMax];
} CchIf;

typedef struct {		// 8 bytes
	short	CNT;
	short	Prg;
	short	Ptr[RemCntMax];
	short	Adrs[RemCntMax];
} CchRem;

typedef struct {		// 32 bytes
	short	Ptr;
	int		*Var[StackForMax];
	short	Adrs[StackForMax];
	int	IntEnd[StackForMax];
	int	IntStep[StackForMax];
	double End[StackForMax];
	double Step[StackForMax];
} StkFor;

typedef struct {		// 8 bytes
	short	WhilePtr;
	short	DoPtr;
	short	WhileAdrs[StackWhileMax];
	short	DoAdrs[StackDoMax];
} StkWhileDo;

typedef struct {		// 8 bytes
	char	Ptr;
	char	flag[StackSwitchMax];
	short	EndAdrs[StackSwitchMax];
	int		Value[StackSwitchMax];
} StkSwitch;

typedef struct {		// 16 bytes
	short	CNT;
	char	TYPE[14];
} CurrentStk;

//-----------------------------------------------------------------------------
#define SkipSpace(SRC) c=SRC[ExecPtr]; while ( c==0x20 ) c=SRC[++ExecPtr]
//------------------------------------------------------------------------------
void ClrCahche();
void InitLocalVar();
int CB_interpreter( char *SRC) ;
int CB_interpreter_sub( char *SRC ) ;
void CB_Prog( char *SRC, int *localvarInt, double *localvarDbl ) ; //	Prog "..."
void CB_Gosub( char *SRC, short *StackGotoAdrs, short *StackGosubAdrs ); //	Gosub N

void Skip_quot( char *SRC ); // skip "..."
void Skip_block( char *SRC );
void Skip_rem( char *SRC );	// skip '...
void CB_Rem( char *SRC, CchRem *CacheRem );
void CB_Lbl( char *SRC, short *StackGotoAdrs );
void CB_Goto( char *SRC, short *StackGotoAdrs );
void CB_If( char *SRC, CchIf *CacheIf );
void CB_Else( char *SRC, CchIf *CacheElse );
void CB_For( char *SRC ,StkFor *StackFor, CurrentStk *CurrentStruct );
void CB_Next( char *SRC ,StkFor *StackFor, CurrentStk *CurrentStruct );
void CB_While( char *SRC, StkWhileDo *StackWhileDo, CurrentStk *CurrentStruct ) ;
void CB_WhileEnd( char *SRC, StkWhileDo *StackWhileDo, CurrentStk *CurrentStruct ) ;
void CB_Do( char *SRC, StkWhileDo *StackWhileDo, CurrentStk *CurrentStruct ) ;
void CB_LpWhile( char *SRC, StkWhileDo *StackWhileDo, CurrentStk *CurrentStruct ) ;
void CB_Switch( char *SRC, StkSwitch *StackSwitch, CurrentStk *CurrentStruct ,CchIf *CacheSwitch ) ;
void CB_Case( char *SRC, StkSwitch *StackSwitch, CurrentStk *CurrentStruct ) ;
void CB_Default( char *SRC, StkSwitch *StackSwitch, CurrentStk *CurrentStruct ) ;
void CB_SwitchEnd( char *SRC, StkSwitch *StackSwitch, CurrentStk *CurrentStruct ) ;
void CB_Break( char *SRC, StkFor *StackFor, StkWhileDo *StackWhileDo, StkSwitch *StackSwitch, CurrentStk *CurrentStruct ) ;

void CB_SaveTextVRAM() ;
void CB_RestoreTextVRAM() ;
void CB_SelectTextVRAM() ;
void CB_SelectTextDD() ;
void CB_SaveGraphVRAM() ;
void CB_RestoreGraphVRAM() ;
void CB_SelectGraphVRAM() ;
void CB_SelectGraphDD() ;
void Scrl_Y();

void CB_ChangeViewWindow() ;
int CB_ChangeGraphicMode( char *SRC ) ;

void CB_Dsz( char *SRC ) ; //	Dsz
void CB_Isz( char *SRC ) ; //	Isz
void CB_Store( char *SRC );	// ->
void CB_Input( char *SRC );
int CB_Fix( char *SRC );
int CB_Sci( char *SRC );
int CB_Norm( char *SRC );
void CB_Rnd();
int CB_Disps( char *SRC ,short dspflag);
void CB_end( char *SRC );

void CB_Cls( char *SRC );
void CB_ClrText( char *SRC );
void CB_ClrGraph( char *SRC );
int RangeErrorCK( char *SRC ) ;

void PlotXYtoPrevPXY() ;
void PlotPreviousPXY() ;
void PlotCurrentXY();

void CB_GetOprand2( char *SRC, int *px, int *py) ;
void CB_GetOprand4( char *SRC, int *px, int *py, int *px2, int *py2) ;
void CB_GetOprand2dbl( char *SRC, double *x, double *y) ;
int CB_GetOprand_int1( char *SRC, int *value ) ;

void CB_RefreshCtrl( char *SRC );	// PutDispDD Refresh control
void CB_RefreshTime( char *SRC );	// PutDispDD Refresh time
void CB_Screen( char *SRC );
void CB_ViewWindow( char *SRC ) ; //	ViewWindow
void CB_FLine( char *SRC) ; //	F-Line
void CB_Line( char *SRC ) ; //	Line
void CB_Vertical( char *SRC ) ; //	Vertical
void CB_Horizontal( char *SRC ) ; //	Horizontal
void CB_Plot( char *SRC ) ; //	Plot
void CB_PlotSub( char *SRC, int mode ); //	mode  1:PlotOn  0:PlotOff  2:PlotChg
void CB_Circle( char *SRC ) ; //	Circle
void CB_PxlSub( char *SRC, int mode ) ; //	mode  1:PxlOn  0:PxlOff  2:PxlChg

void StoPictSmem( int pictNo, int offset );
void StoPict( int pictNo);
void RclPict( int pictNo, int errorcheck);
void CB_DrawGraph(  char *SRC );
void CB_GraphY( char *SRC );
int  CB_GraphXYEval( char *SRC ) ;
void CB_GraphXY( char *SRC );
void CB_StoPict( char *SRC ) ; //	StoPict
void CB_RclPict( char *SRC ) ; //	RclPict
void CB_BG_None( char *SRC ) ; //	BG_None
void CB_BG_Pict( char *SRC ) ; //	BG_Pict

void CB_Locate( char *SRC ) ;
void CB_LocateYX( char *SRC );
void CB_Text( char *SRC ) ; //	Text
void CB_ReadGraph( char *SRC );	// ReadGraph(px1,py1, px2,py2)->Mat C
void CB_WriteGraph( char *SRC );	// WriteGraph x,y,wx,wy,Mat A ([2,2]),modify,kind
void CB_RectSub( char *SRC , int RectMode ) ; // RectMode  0:Rect  1:RectFill
void CB_Rect( char *SRC ) ; 	// Rect x1,y1,x2,y2,mode 
void CB_FillRect( char *SRC ) ; // FillRect x1,y1,x2,y2,mode 
void CB_DotShape( char *SRC ) ; // DotShape (x1,y1,x2,y2,typ,mode1,mode2,pattern1,pattern2)
void CB_DotGet( char *SRC );	// DotGet(px1,py1, px2,py2)->Mat B [x,y]
void CB_DotPut( char *SRC );	// DotPut(Mat B[x,y], px1,py1, px2,py2)
void CB_DotTrim( char *SRC );	// DotTrim(Mat A,x1,y1,x2,y2)->Mat B    =>[X,Y]
void CB_DotLife( char *SRC ) ;

void CB_FkeyMenu( char *SRC) ;
int CB_PopUpWin( char *SRC );	//
void CB_Menu( char *SRC, short *StackGotoAdrs) ;		// Menu "title name","Branch name1",1,"Branch name2",2,"Branch name3",3,...
void CB_Wait( char *SRC ) ;

void CB_PlotLineColor( char *SRC );
void CB_BackColor( char *SRC );
int CB_GetColor( char *SRC );
unsigned short CB_RGB( char *SRC ) ;	// r,g,b    return : color code

void ReadVram_fx( unsigned char *pDATA );
void WriteVram_fx( unsigned char *pDATA , int Kind );
//-----------------------------------------------------------------------------
typedef struct {		// 16 bytes
	short	alias;
	char	org;
	char	len;
	char	name[8];
} ALIAS_VAR;

#define ALIASVARMAX 36
#define ALIASVARMAXMAT 36
extern	ALIAS_VAR	AliasVarCode[ALIASVARMAX];
extern	ALIAS_VAR	AliasVarCodeMat[ALIASVARMAXMAT];
extern	int AliasVarMAX;
extern	int AliasVarMAXMat;

void CB_AliasVarClr();
void CB_AliasVar( char *SRC ) ;	// AliasVar A=
int GetVarName( char *SRC, int *ptr, char *name, int *len );

//-----------------------------------------------------------------------------
typedef struct {
	char Draw;			// 0:off  1:on
	char GraphType;		// 0;Scatter 1:xyline  2:
	char xList;			// List 1-26
	char yList;			// List 1-26
	char Freq;			// -1:1  1-26:List 1-26
	char MarkType;		// 0:Square  1:Cross  2:Dot
} tdrawstat;
extern	tdrawstat Sgraph[3];

void CB_S_Gph_init( int No ) ;	// S-Gph1 DrawOff,Scatter,List 1,List 2,1,Square
void CB_S_Gph( char *SRC, int No ) ;
void CB_S_WindAuto( char *SRC ) ;
void CB_S_WindMan( char *SRC ) ;
void CB_DrawStat( char *SRC ) ;
int CB_Disp( char *SRC );		// Disp "A=",A

void CB_StoCapt( char *SRC ) ; //	StoCapt
void CB_RclCapt( char *SRC ) ; //	RclCaptvoid StoVwin( int n ) ;
void RclVwin( int n ) ;
void CB_StoVWin( char *SRC ) ;
void CB_RclVWin( char *SRC ) ;

void CB_Send( char *SRC );				// Receive(
void CB_Receive( char *SRC );			// OpenComport38k
void CB_OpenComport38k( char *SRC );	// CloseComport38k
void CB_CloseComport38k( char *SRC );	// Send38k
void CB_Send38k( char *SRC );			// Send38k
void CB_Receive38k( char *SRC );		// Receive38k

void CB_Beep( char *SRC );

int Search_Lbl( char *SRC, int lc );
int CB_SearchProg( char *name ) ; //	Prog search